--
-- Filename: joinServerRequestSynch.lua
-- Author: Martin Fabík (LoogleCZ)
--
-- This event is part of NotesMod.
--

joinServerRequestSynch = {};
joinServerRequestSynch_mt = Class(joinServerRequestSynch, Event);

InitEventClass(joinServerRequestSynch, "joinServerRequestSynch");

function joinServerRequestSynch:emptyNew()
    local self = Event:new(joinServerRequestSynch_mt);
    return self;
end;

function joinServerRequestSynch:new()
    local self = joinServerRequestSynch:emptyNew();
    return self;
end;

function joinServerRequestSynch:readStream(streamId, connection)
	g_currentMission.NotesBase.notes = {};
	local number = streamReadInt16(streamId);
	for i = 1, number do
		local note = {};
		note.name = streamReadString(streamId);
		note.content = streamReadString(streamId);
		note.author = streamReadString(streamId);
		table.insert(g_currentMission.NotesBase.notes, note);
	end;
	self:run(connection);
end;

function joinServerRequestSynch:writeStream(streamId, connection)
	local number = table.getn(g_currentMission.NotesBase.notes);
	streamWriteInt16(streamId, number);
	for i = 1, number do
		streamWriteString(streamId, g_currentMission.NotesBase.notes[i].name);
		streamWriteString(streamId, g_currentMission.NotesBase.notes[i].content);
		streamWriteString(streamId, g_currentMission.NotesBase.notes[i].author);
	end;
end;

function joinServerRequestSynch:run(connection)
	for k,v in pairs(g_currentMission.NotesBase.notes) do
		Notes:drawNote(v);
	end;
end;