--
-- Filename: removeNoteEvent.lua
-- Author: Martin Fabík (LoogleCZ)
--
-- This event is part of NotesMod.
--

removeNoteEvent = {};
removeNoteEvent_mt = Class(removeNoteEvent, Event);

InitEventClass(removeNoteEvent, "removeNoteEvent");

function removeNoteEvent:emptyNew()
    local self = Event:new(removeNoteEvent_mt);
    return self;
end;

function removeNoteEvent:new(index)
    local self = removeNoteEvent:emptyNew();
	self.noteIndex = index;
    return self;
end;

function removeNoteEvent:readStream(streamId, connection)
	self.noteIndex = streamReadInt16(streamId);
	self:run(connection);
end;

function removeNoteEvent:writeStream(streamId, connection)
	streamWriteInt16(streamId, self.noteIndex);
end;

function removeNoteEvent:run(connection)
	table.remove(g_currentMission.NotesBase.notes,self.noteIndex);
	if g_client ~= nil then
		g_currentMission.NotesBase.itemList.elements = {};
		for k,v in pairs(g_currentMission.NotesBase.notes) do
			Notes:drawNote(v);
		end;
		g_currentMission.NotesBase.selectedIndex = nil;
		g_currentMission.NotesBase.removeItemGUI:close();
		Notes:freezePlayer();
		g_currentMission.NotesBase.itemList.selectedEntry = 1;
	end;
	if not connection:getIsServer() then
		g_server:broadcastEvent(removeNoteEvent:new(self.noteIndex));
	end;
end;

function removeNoteEvent:sendEvent(index)
	if g_server ~= nil then
		table.remove(g_currentMission.NotesBase.notes,index);
		if g_client ~= nil then
			g_currentMission.NotesBase.itemList.elements = {};
			for k,v in pairs(g_currentMission.NotesBase.notes) do
				Notes:drawNote(v);
			end;
			g_currentMission.NotesBase.selectedIndex = nil;
			g_currentMission.NotesBase.removeItemGUI:close();
			Notes:freezePlayer();
			g_currentMission.NotesBase.itemList.selectedEntry = 1;
		end;
		g_server:broadcastEvent(removeNoteEvent:new(index));
	else
		g_client:getServerConnection():sendEvent(removeNoteEvent:new(index));
	end;
end;
